unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    btnPlace: TButton;
    Image1: TImage;
    Timer1: TTimer;
    btnStartStop: TButton;
    Label3: TLabel;
    tbChangeDirProb: TTrackBar;
    Label4: TLabel;
    lblChangeDirProb: TLabel;
    tbMaxEnergy: TTrackBar;
    lblMaxEnergy: TLabel;
    Image2: TImage;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    cbWallEnergy: TCheckBox;
    cbArbuEnergy: TCheckBox;
    cbWallDir: TCheckBox;
    cbArbuDir: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    udInterval: TUpDown;
    lblInterval: TLabel;
    lblCol1: TLabel;
    lblCol2: TLabel;
    lblCol3: TLabel;
    procedure btnPlaceClick(Sender: TObject);
    procedure btnStartStopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure tbChangeDirProbChange(Sender: TObject);
    procedure tbMaxEnergyChange(Sender: TObject);
    procedure udIntervalClick(Sender: TObject; Button: TUDBtnType);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TDir = (North, East, South, West);

  TArbuzoid = record
    Num: byte;
    Color: TColor;
    Coord: TPoint;
    Direction: TDir;
    Energy: integer;
  end;

const
  ArbSize = 10;

var
  ZColors: array[1..3] of TColor;
  Zoids: array [1..45] of TArbuzoid;
  ChangeDirProb, MaxEnergy: byte;
  Form1: TForm1;
  TimerInterval: integer;
  
implementation

function Distance(A, B: TArbuzoid): Real;
begin
  Result := Sqrt(Sqr(A.Coord.X - B.Coord.X) + Sqr(A.Coord.Y - B.Coord.Y));
end;

procedure DrawArbuzoid(Arb: TArbuzoid);
var
  X1, X2, Y1, Y2: integer;
begin
  Form1.Image1.Canvas.Pen.Color := Arb.Color;
  Form1.Image1.Canvas.Brush.Color := Arb.Color;
  Form1.Image1.Canvas.Rectangle(Arb.Coord.X - ArbSize, Arb.Coord.Y - ArbSize, Arb.Coord.X + ArbSize, Arb.Coord.Y + ArbSize);
  case Arb.Direction of
    North: begin X1 := Arb.Coord.X - 3; Y1 := Arb.Coord.Y - 3; X2 := Arb.Coord.X + 3; Y2 := Y1; end;
    East:  begin X1 := Arb.Coord.X + 3; Y1 := Arb.Coord.Y + 3; X2 := X1; Y2 := Arb.Coord.Y - 3; end;
    South: begin X1 := Arb.Coord.X - 3; Y1 := Arb.Coord.Y + 3; X2 := Arb.Coord.X + 3; Y2 := Y1; end;
    West:  begin X1 := Arb.Coord.X - 3; Y1 := Arb.Coord.Y + 3; X2 := X1; Y2 := Arb.Coord.Y - 3; end;
  end;

  Form1.Image1.Canvas.Pen.Color := clBlack;
  Form1.Image1.Canvas.Brush.Color := clWhite;
  Form1.Image1.Canvas.Ellipse(X1 - 3, Y1 - 3, X1 + 3, Y1 + 3);
  Form1.Image1.Canvas.Ellipse(X2 - 3, Y2 - 3, X2 + 3, Y2 + 3);
end;

procedure DrawAll;
var
  i: integer;
begin
  for i := 1 to 45 do DrawArbuzoid(Zoids[i]);
end;

procedure InitArbuzoids;
var
  i, j: integer;
begin
  Randomize;
  for i := 1 to 45 do begin
    Zoids[i].Num := i;

    Zoids[i].Direction := TDir(Random(4));

    if i < 14 then Zoids[i].Color := ZColors[1];
    if (i >= 14) and (i < 29) then Zoids[i].Color := ZColors[2];
    if (i >= 29) then Zoids[i].Color := ZColors[3];

    repeat
      Zoids[i].Coord.X := Random(Form1.Image1.Width - 2*ArbSize) + ArbSize;
      Zoids[i].Coord.Y := Random(Form1.Image1.Height - 2*ArbSize) + ArbSize;
      for j := 1 to i do begin
        if Distance(Zoids[i], Zoids[j]) < 3*ArbSize then break;
      end;
    until i = j;
  end;
end;

procedure MakeMove(var Arb: TArbuzoid);
begin
  if Arb.Energy = 0 then begin
    Arb.Energy := Random(MaxEnergy+1);
    if Random(100) < ChangeDirProb then Arb.Direction := TDir(Random(4));
  end;
end;

procedure MakeMoveAll;
var
  i: byte;
begin
  for i := 1 to 45 do MakeMove(Zoids[i]);
end;

procedure WallCollision(var Arb: TArbuzoid);
begin
  if form1.cbWallEnergy.Checked then Arb.Energy := 0;
  if form1.cbWallDir.Checked then Arb.Direction := TDir(Random(4));
end;

procedure ArbuCollision(var Arb: TArbuzoid);
begin
  if form1.cbArbuEnergy.Checked then Arb.Energy := 0;
  if form1.cbArbuDir.Checked then Arb.Direction := TDir(Random(4));
end;

procedure MoveArbuzoid(var Arb: TArbuzoid);
var
  i, j, CollArb: byte;
  Collision: boolean;
  Color1, Color2, NewColor: TColor;
begin
  Collision := false;
  CollArb := 0;
    for j := 1 to 45 do begin
      if j <> Arb.Num then begin
        case Arb.Direction of
          North: begin
            if (Arb.Coord.Y - ArbSize = Zoids[j].Coord.Y + ArbSize) and (Abs(Arb.Coord.X - Zoids[j].Coord.X) < 2*ArbSize) then begin
              Collision := True;
              CollArb := j;
              break;
            end;
          end;
          East: begin
            if (Arb.Coord.X + ArbSize = Zoids[j].Coord.X - ArbSize) and (Abs(Arb.Coord.Y - Zoids[j].Coord.Y) < 2*ArbSize) then begin
              Collision := True;
              CollArb := j;
              break;
            end;
          end;
          South: begin
            if (Arb.Coord.Y + ArbSize = Zoids[j].Coord.Y - ArbSize) and (Abs(Arb.Coord.X - Zoids[j].Coord.X) < 2*ArbSize) then begin
              Collision := True;
              CollArb := j;
              break;
            end;
          end;
          West: begin
            if (Arb.Coord.X - ArbSize = Zoids[j].Coord.X + ArbSize) and (Abs(Arb.Coord.Y - Zoids[j].Coord.Y) < 2*ArbSize) then begin
              Collision := True;
              CollArb := j;
              break;
            end;
          end;
        end;
      end;
    end;

    if Collision then begin
      ArbuCollision(Arb);
      ArbuCollision(Zoids[CollArb]);
    end;

    if Collision and (Arb.Color <> Zoids[CollArb].Color) then begin
      Color1 := Arb.Color;
      Color2 := Zoids[CollArb].Color;
      if (Color1 = ZColors[1]) and (Color2 = ZColors[2]) then NewColor := ZColors[3];
      if (Color2 = ZColors[1]) and (Color1 = ZColors[2]) then NewColor := ZColors[3];
      if (Color1 = ZColors[1]) and (Color2 = ZColors[3]) then NewColor := ZColors[2];
      if (Color2 = ZColors[1]) and (Color1 = ZColors[3]) then NewColor := ZColors[2];
      if (Color1 = ZColors[2]) and (Color2 = ZColors[3]) then NewColor := ZColors[1];
      if (Color2 = ZColors[2]) and (Color1 = ZColors[3]) then NewColor := ZColors[1];
      Arb.Color := NewColor;
      Zoids[CollArb].Color := NewColor;
    end;

    if (not(Collision)) and (Arb.Energy > 0) then begin
      case Arb.Direction of
        North: if Arb.Coord.Y - ArbSize > 0 then Dec(Arb.Coord.Y) else WallCollision(Arb);
        East:  if Arb.Coord.X + ArbSize < Form1.Image1.Width then Inc(Arb.Coord.X) else WallCollision(Arb);  //begin Arb.Steps := 0;
        South: if Arb.Coord.Y + ArbSize < Form1.Image1.Height then Inc(Arb.Coord.Y) else WallCollision(Arb); //begin Arb.Steps := 0;
        West:  if Arb.Coord.X - ArbSize > 0 then Dec(Arb.Coord.X) else WallCollision(Arb); //begin Arb.Steps := 0;
      end;
    end;

  if Arb.Energy > 0 then Dec(Arb.Energy);
end;

procedure MoveAll;
var
  i: byte;
begin
  for i := 1 to 45 do MoveArbuzoid(Zoids[i]);
end;

procedure ShowStats;
var
  i: byte;
  ColCount: array[1..3] of byte;
begin
  ColCount[1] := 0;
  ColCount[2] := 0;
  ColCount[3] := 0;
  for i := 1 to 45 do begin
    if Zoids[i].Color = ZColors[1] then Inc(ColCount[1]);
    if Zoids[i].Color = ZColors[2] then Inc(ColCount[2]);
    if Zoids[i].Color = ZColors[3] then Inc(ColCount[3]);
  end;

  Form1.lblCol1.Caption := IntToStr(ColCount[1]);
  Form1.lblCol2.Caption := IntToStr(ColCount[2]);
  Form1.lblCol3.Caption := IntToStr(ColCount[3]);

  Form1.Image2.Canvas.MoveTo(Form1.Image2.Width - 1, 0);
  Form1.Image2.Canvas.Pen.Color := ZColors[1];
  Form1.Image2.Canvas.LineTo(Form1.Image2.Width - 1, ColCount[1] - 1);
  Form1.Image2.Canvas.Pen.Color := ZColors[2];
  Form1.Image2.Canvas.LineTo(Form1.Image2.Width - 1, ColCount[1] + ColCount[2] - 1);
  Form1.Image2.Canvas.Pen.Color := ZColors[3];
  Form1.Image2.Canvas.LineTo(Form1.Image2.Width - 1, Form1.Image2.Height);
  BitBlt(Form1.Image2.Canvas.Handle, 0, 0, Form1.Image2.Width, Form1.Image2.Height, Form1.Image2.Canvas.Handle, 1, 0, srccopy);
end;

{$R *.dfm}

procedure TForm1.btnPlaceClick(Sender: TObject);
var
  aa: TArbuzoid;
begin
  BitBlt(Image1.Canvas.Handle, 0, 0, Image1.Width, Image1.Height, Image1.Canvas.Handle, 0, 0, blackness);
  InitArbuzoids;
  DrawAll;
  ShowStats;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ZColors[1] := RGB(255, 128, 64);
  ZColors[2] := RGB(230, 235, 12);
  ZColors[3] := RGB(83, 232, 175);

  lblCol1.Caption := '';
  lblCol2.Caption := '';
  lblCol3.Caption := '';

  lblCol1.Font.Color := ZColors[1];
  lblCol2.Font.Color := ZColors[2];
  lblCol3.Font.Color := ZColors[3];

  form1.DoubleBuffered := true;

  BitBlt(Image1.Canvas.Handle, 0, 0, Image1.Width, Image1.Height, Image1.Canvas.Handle, 0, 0, blackness);
  BitBlt(Image2.Canvas.Handle, 0, 0, Image2.Width, Image2.Height, Image2.Canvas.Handle, 0, 0, blackness);

  ChangeDirProb := tbChangeDirProb.Position;
  lblChangeDirProb.Caption := IntToStr(ChangeDirProb)+'%';

  MaxEnergy := tbMaxEnergy.Position;
  lblMaxEnergy.Caption := IntToStr(MaxEnergy);

  TimerInterval := udInterval.Position;
  lblInterval.Caption := IntToStr(TimerInterval);

  BtnPlace.Click;
end;

procedure TForm1.btnStartStopClick(Sender: TObject);
begin
  Timer1.Enabled := not(Timer1.Enabled);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  MakeMoveAll;
  MoveAll;
  BitBlt(Image1.Canvas.Handle, 0, 0, Image1.Width, Image1.Height, Image1.Canvas.Handle, 0, 0, blackness);
  DrawAll;
  ShowStats;
end;

procedure TForm1.tbChangeDirProbChange(Sender: TObject);
begin
  ChangeDirProb := tbChangeDirProb.Position;
  lblChangeDirProb.Caption := IntToStr(ChangeDirProb)+'%';
end;

procedure TForm1.tbMaxEnergyChange(Sender: TObject);
begin
  MaxEnergy := tbMaxEnergy.Position;
  lblMaxEnergy.Caption := IntToStr(MaxEnergy);
end;

procedure TForm1.udIntervalClick(Sender: TObject; Button: TUDBtnType);
begin
  TimerInterval := udInterval.Position;
  Timer1.Interval := TimerInterval;
  lblInterval.Caption := IntToStr(TimerInterval);
end;

end.
